// Задача "Прыгучее путешествие"
// 9-ая Интернет-олимпиада сезона 2006-2007, базовый уровень
// Автор задачи: Александр Торопов, toropov@rain.ifmo.ru
// Автор решения: Федор Царев, tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;
import java.math.*;

public class jump_ft implements Runnable {

	private Scanner in;
	private PrintWriter out;
	String fname = "jump";

	private final BigInteger FOUR = BigInteger.valueOf(4);
	private final BigInteger TWENTY = BigInteger.valueOf(20);

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}

	void checkCoord(int x, int y) {
		myAssert(Math.abs(x) <= 10000, "|x| must be <= 10000");
		myAssert(Math.abs(y) <= 10000, "|y| must be <= 10000");
	}

	public void solve() {
		int n = in.nextInt();
		myAssert(1 <= n && n <= 100000, "n must be between 1 and 100000");
		int xb = in.nextInt();
		int yb = in.nextInt();
		int l = in.nextInt();
		myAssert(0 <= l && l <= 5000, "l must be between 0 and 5000");
		for (int i = 0; i < n; i++) {
			int x = in.nextInt();
			int y = in.nextInt();
			int dx = x - xb;
			int dy = y - yb;
			if (dx * dx + dy * dy <= l * l) {
				out.println(i + 1);
				return;
			}			
		}
		out.println("Yes");
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public jump_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		new Thread(new jump_ft()).start();
	}

}